import updateKeys from './lib/updateKeys';

export default function decryptFile(dv: DataView, length: number, [key0, key1, key2]: [number, number, number]) {
  const decryptedBuffer = new ArrayBuffer(length - 12);
  const dvOut = new DataView(decryptedBuffer);

  for (let i = 0; i < length; i += 1) {
    //read and decrypt byte
    let curChar = dv.getUint8(i);
    const keyPart = (key2 | 2) & 0xFFFF;
    const decryptedByte = (keyPart * (keyPart ^ 1)) >>> 8;
    curChar ^= decryptedByte & 0xFF;
    //Skip the first 12 bytes (random encryption header)
    if (i >= 12) {
      dvOut.setUint8(i - 12, curChar);
    }

    //update keys
    [key0, key1, key2] = updateKeys([key0, key1, key2], curChar);
  }

  return dvOut;
}
